#ifndef VLOC_MEASURE_H
#define VLOC_MEASURE_H

//#ifndef EIGEN_DONT_ALIGN_STATICALLY
//#define EIGEN_DONT_ALIGN_STATICALLY
//#endif

#include "base_measure.h"
namespace Localization {
namespace Ego {

class VLocMeasure : public BaseMeasure {
public:
    VLocMeasure() = delete;
    VLocMeasure(const VLocMeasure &) = delete;
    VLocMeasure & operator=(const VLocMeasure &) = delete;
    VLocMeasure(const MeasurementType &mType, const RecLocInfo &vLocInfo);
    void CheckValid();
    // ****** function ****** //
    bool Update(const State &state, State &nextState) override;
    bool UpdateStateVLoc(const State &state, State &nextState, const Eigen::VectorXd &innov,
        const Eigen::MatrixXd &mH);
    Eigen::VectorXd MeasurementEquation(const State &state) const;
    void ObserveVloc(const State &state, State &nextState, Eigen::VectorXd &innov,
                             Eigen::MatrixXd &mH);

    Eigen::Vector3d posUTM_{0,0,0};
    Eigen::Vector3d posLLA_{0,0,0};
    Eigen::Vector3d attitude_{0,0,0};
    Eigen::Quaterniond quatUTM_{1,0,0,0};

    double pNoiseVar_{0.05 * 0.05};
    double rNoiseVar_{0.05 * 0.05};
    double score_{0.0};
    unsigned int status_{0U};
    unsigned int vIntegratedState_{0U};
    static double latestUpdateTime_;

}; // class VLocMeasure

} // namespace Ego
} // namespace Localizaiton
#endif
